//
//  TSGeneralRintoneVC.swift
//  AIRingtone
//
//  Created by 100Years on 2025/3/6.
//

class TSGeneralRintoneVC: TSBottomAlertVC {
    
    var infoModel:TSActionInfoModel?
    var complete:((TSActionInfoModel)->Void)
    
    var aiText:String
    init(aiText: String,complete:@escaping ((TSActionInfoModel)->Void)) {
        self.aiText = aiText
        self.complete = complete
        super.init()
    }
    
    lazy var viewModel: TSGeneralRintoneVM = {
        let viewModel:TSGeneralRintoneVM = TSGeneralRintoneVM()
        viewModel.aiText = aiText
        return viewModel
    }()
    
    @MainActor required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    lazy var ringView: TSRingToneCellView = {
        let ringToneView = TSRingToneCellView()
        ringToneView.playBtn.addTarget(self, action: #selector(clickPlay), for: .touchUpInside)
        return ringToneView
    }()
    
    //############################## 生成动画 ##############################
    lazy var generateInView : TSCommonloadingView = {
        let generateInView = TSCommonloadingView()
        generateInView.cancelBtn.addTarget(self, action: #selector(closePage), for: .touchUpInside)
        return generateInView
    }()

    
    override func createView() {
        super.createView()
        
        view.addSubview(generateInView)
        generateInView.snp.makeConstraints { make in
            make.top.bottom.leading.trailing.equalTo(0)
        }

        diyView.addSubview(ringView)
        ringView.snp.makeConstraints { make in
            make.top.equalTo(98)
            make.centerX.equalToSuperview()
            make.width.equalTo(k_ScreenWidth - 40)
            make.height.equalTo(72)
        }
        
        diyView.addSubview(regenerateBtn)
        regenerateBtn.snp.makeConstraints { make in
            make.top.equalTo(ringView.snp.bottom).offset(16)
            make.centerX.equalToSuperview()
        }
        saveBtn.setTitle("Set As Ringtone".localized, for: .normal)
        resultIconImageView.image = resultIcon
        bottomViewH = 340.0
        
        
        diyView.addSubview(failView)
        failView.snp.updateConstraints { make in
            make.centerY.equalToSuperview().offset(0)
        }
    }
    
    @objc override func closePage() {
        viewModel.cancelAllRequest()
        self.dismiss(animated: true, completion: nil)
    }
    
    override func clickAgainBtn() {
        viewModel.creatRintone(text:aiText)
    }
    
    @objc override func clickSubmitBtn(){

        
    }
    
    @objc func clickPlay(){
        ringView.isPlay = !ringView.isPlay
        viewModel.changeAudioState(isPlay: ringView.isPlay)
    }
    
    override func dealThings() {
        viewModel.creatRintone(text: self.aiText)
        viewModel.$stateDatauPblished.receive(on: DispatchQueue.main).sink {[weak self]  (state,model) in
            guard let self = self else { return }
            self.upDateView(state: state, model: model)
        }.store(in: &cancellable)
    }
}

extension TSGeneralRintoneVC{
    func setRingViewData(model:TSActionInfoModel) {
        
//        ringView.cellView.nameLab.text = model.ringtoneName
//        ringView.cellView.coverImageView.setAsyncImage(urlString: model.ringtoneCover,contentMode: .scaleAspectFill)
//        ringView.cellView.timeLab.text = duration.floatToMinuteSecond()
//        vm.playRingtone(ringtone: model.ringtone)
        
    }
}

